Subject: Re: [PATCH 1/3] arm64: dts: qcom: sc7180: Add APSS watchdog node

From: Stephen Boyd <[email-masked]>
Date: Mon, 16 Dec 2019 08:51:13 -0800

Quoting Doug Anderson (2019-12-11 11:25:23)
> On Tue, Dec 10, 2019 at 8:30 PM Sai Prakash Ranjan
> <[email-masked]> wrote:
> 
> Unrelated to sc7180, but it also feels like something is awfully
> screwy here in terms of the various Qualcomm device tree files
> referring to watchdog timers.  It feels wrong, but perhaps you can
> educate me on how it works and I'll see the light.  Specifically:
> 
> 1. It seems like the same node is used for two things on other Qualcomm SoCs
> 
> If I grep the bindings for "qcom,kpss-timer" or "qcom,scss-timer", I
> get two hits:
> 
> Documentation/devicetree/bindings/timer/qcom,msm-timer.txt
> Documentation/devicetree/bindings/watchdog/qcom-wdt.txt
> 
> ...and, in fact, there appear to be two drivers claiming compatibility here:
> 
> drivers/clocksource/timer-qcom.c
> drivers/watchdog/qcom-wdt.c
> 
> That seems super odd to me.  Is that really right?  We have two
> drivers probing against the same device tree nodes?  ...and that's OK?
>  If so, why does only one of the bindings list the SoC-specific
> bindings names?

The drivers/clocksource/timer-qcom.c file isn't a "driver", at least not
in the linux device driver model. It's a clocksource driver that probes
early so in this case the clocksource code runs early and then the
qcom-wdt driver probes later as a platform device driver.

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel